'use strict';

var _templateObject = _taggedTemplateLiteral(['\n      0% {\n        opacity: 0;\n      }\n      100% {\n        opacity: 1;\n      }\n    '], ['\n      0% {\n        opacity: 0;\n      }\n      100% {\n        opacity: 1;\n      }\n    ']),
    _templateObject2 = _taggedTemplateLiteral(['', ''], ['', '']);

var _expect = require('expect');

var _expect2 = _interopRequireDefault(_expect);

var _sheet = require('../../vendor/glamor/sheet');

var _keyframes2 = require('../keyframes');

var _keyframes3 = _interopRequireDefault(_keyframes2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * Setup
 */
var index = 0;
var keyframes = (0, _keyframes3.default)(function () {
  return 'keyframe_' + index++;
});
var getInjectedCSS = function getInjectedCSS() {
  return _sheet.StyleSheet.instance.rules().map(function (rule) {
    return rule.cssText;
  }).join(' ');
};

describe('keyframes', function () {
  beforeEach(function () {
    if (_sheet.StyleSheet.instance && _sheet.StyleSheet.instance.sheet) _sheet.StyleSheet.instance.flush();
    index = 0;
  });

  it('should return its name', function () {
    (0, _expect2.default)(keyframes(_templateObject)).toEqual('keyframe_0');
  });

  it('should insert the correct styles', function () {
    var rules = '\n      0% {\n        opacity: 0;\n      }\n      100% {\n        opacity: 1;\n      }\n    ';

    var name = keyframes(_templateObject2, rules);
    (0, _expect2.default)(getInjectedCSS().replace(/\s+/g, ' ')).toEqual('\n      @keyframes keyframe_0 {\n        0% {\n          opacity: 0;\n        }\n        100% {\n          opacity: 1;\n        }\n      }\n    '.trim().replace(/\s+/g, ' '));
  });
});