'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _camelizeStyleName = require('fbjs/lib/camelizeStyleName');

var _camelizeStyleName2 = _interopRequireDefault(_camelizeStyleName);

var _hyphenateStyleName = require('fbjs/lib/hyphenateStyleName');

var _hyphenateStyleName2 = _interopRequireDefault(_hyphenateStyleName);

var _autoprefix = require('glamor/lib/autoprefix');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

exports.default = function (root) {
  root.walkDecls(function (decl) {
    /* No point even checking custom props */
    if (decl.prop.startsWith('--')) return;

    var objStyle = _defineProperty({}, (0, _camelizeStyleName2.default)(decl.prop), decl.value);
    var prefixed = (0, _autoprefix.autoprefix)(objStyle);
    Object.keys(prefixed).reverse().forEach(function (newProp) {
      decl.cloneBefore({
        prop: (0, _hyphenateStyleName2.default)(newProp),
        value: prefixed[newProp]
      });
    });
    decl.remove();
  });
};

module.exports = exports['default'];